/********************************************************************
	created:	2007/05/08
	filename: 	FontDB.h
	file base:	FontDB
	file ext:	h
	author:		
	purpose:	ŪëإߦrDatabase
*********************************************************************/

#ifndef _FONT_DATABASE_
#define _FONT_DATABASE_

#include "stdio.h"		//Barry 2008-05-29
#include "Huffman.h"
///080430
//#define FONTDB_PRIVATE_CODEPAGE
#ifdef FONTDB_PRIVATE_CODEPAGE
	#include "iconv.h"
#endif
///

/**************************************************
//	API for Users
**************************************************/
#ifndef _BYTE_WORD_
#define _BYTE_WORD_
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
#endif

#ifndef _BOOL_
#define _BOOL_
typedef unsigned char bool;
//#define bool Uint8//BOOL
#define true 1//TRUE
#define false 0//FALSE
#endif

///080115
#define MAX_RANGE_NUMBER 24
//#define MAX_RANGE_NUMBER 10
///
#define MAX_CORRESPOND_NUMBER 30
#define MAX_HUFFMAN_TABLE_NUM 4
#define MAX_PREDICT_SIZE 256

///080104 ۭqUnicode
#define UCS2_CODING				16
///
#define ANSI_CHARSET            0
#define DEFAULT_CHARSET         1
#define SYMBOL_CHARSET          2
#define SHIFTJIS_CHARSET        128
#define HANGEUL_CHARSET         129
#define HANGUL_CHARSET          129
#define GB2312_CHARSET          134
#define CHINESEBIG5_CHARSET     136
#define OEM_CHARSET             255
#define JOHAB_CHARSET           130
#define HEBREW_CHARSET          177
#define ARABIC_CHARSET          178
#define GREEK_CHARSET           161
#define TURKISH_CHARSET         162
#define VIETNAMESE_CHARSET      163
#define THAI_CHARSET            222
#define EASTEUROPE_CHARSET      238
#define RUSSIAN_CHARSET         204
#define MAC_CHARSET             77
#define BALTIC_CHARSET          186

///080514 sXW
#define CODE_PAGE_NAME_ISO8859_1	"ISO-8859-1"
#define CODE_PAGE_NAME_BIG_5		"BIG-5"
#define CODE_PAGE_NAME_GB2312		"GB2312"
#define CODE_PAGE_NAME_SJIS			"SJIS"	//"SHIFT-JIS"	//Barry 2008-09-03
#define CODE_PAGE_NAME_KSC			"CP949"
#define CODE_PAGE_NAME_UTF_8		"UTF-8"
#define CODE_PAGE_NAME_UCS_2		"UCS-2LE"
#define CODE_PAGE_NAME_CYRILLIC            "CP1251"
///

typedef struct _CODERANGE
{
	BYTE Start;			//sXU(p)
	BYTE End;			//sXW(j)
}Code_Range;

typedef struct _CORRESPONDRANGEPAIR
{
	BYTE High_Index;	//HiBytedindex
	BYTE Low_Index;		//LoBytedindex
}Correspond_Range_Pair;

typedef struct _PREDICT
{
	WORD size;
	BYTE table[MAX_PREDICT_SIZE];
}PREDICT;

typedef struct _FONTDB
{
//public
	//rjp
	BYTE CharSet;					//yt
	WORD FontSize;					//r

//#ifdef USE_DESC_TV			//Barry 2008-05-29
	///070824 O_ϥΤϿ
	bool bUseFontAA;
	///
	///070831 O_ϥYp
	bool bScaleDown;
	///
//#endif		//Barry 2008-05-29

///080430 ήXiۭqANglobalX
#ifdef FONTDB_PRIVATE_CODEPAGE
	bool bUsePrivateCodepage;
	iconv_t cd_utf8_2_local;
	iconv_t cd_local_2_ucs2;
#endif
///
	
	//줸sXd
	WORD High_Byte_Range_Num;
	Code_Range High_Byte_Range[MAX_RANGE_NUMBER];

	//C줸sXd
	WORD Low_Byte_Range_Num;
	Code_Range Low_Byte_Range[MAX_RANGE_NUMBER];

	//C줸d
	WORD Correspond_Num;
	Correspond_Range_Pair Correspond[MAX_CORRESPOND_NUMBER];

//private
	FILE* FontFile;
	WORD Total_Char_Num;			//r`

	//Huffman Table	(@Huffman Table@ӦPsPredict Table)
	WORD Huffman_Table_Num;
	HUFFMAN* HuffTable[MAX_HUFFMAN_TABLE_NUM];

	//Predict Table
	WORD Predict_Table_Num;
	PREDICT* Predict_Table[MAX_HUFFMAN_TABLE_NUM];
	
	//CCodeWordbrɤm
	DWORD* CodePos;		//CodePos[Total_Char_Num+1]
}FONT_DB;

//إFontDB
FONT_DB* Create_FontDB(char* FileName);
///080514
#ifdef FONTDB_PRIVATE_CODEPAGE
int FontDB_Set_Private_CodePage(FONT_DB* pFontDB, char* strCode);
#endif
///

//oYrv
bool Draw_Char_Image(FONT_DB* pFontDB, WORD Code, BYTE* ImageBuffer, /*WORD BufferWidthAlign, */WORD *pOutCharHeight, WORD *pOutCharWidth);

//FontDB
bool Release_FontDB(FONT_DB** ppFontDB);

#endif

