#Barry 2008-05-09
SK2851 = yes
MPLAYER_LITE = no

# ARC mplayer build

# Headline config items
ARC_BUILD = yes
ARC_TARGET = yes
ARC_AURORA = yes
ARC_DEMO = yes
ARC_DISPLAY_CENTRING = yes
ARC_MP3 = yes
GUC_JPEG = yes

ifeq ($(MPLAYER_LITE),yes)
ARC_H264 = no 
ARC_VC1 = no
ARC_WMA = no
ARC_AAC = no
AMR_NB=no
AMR_WB=no
LIBA52 = no
TREMOR = no
MPLAYER_NETWORK = no
STREAMING_LIVE_DOT_COM = no
NO_MP_MSG = yes
else
ARC_H264 = yes
ifeq ($(SK2851),yes)
ARC_VC1 = yes
else
ARC_VC1 = no
endif
ARC_WMA = yes
ARC_AAC = yes
AMR_NB=yes
AMR_WB=yes
LIBA52 = yes
TREMOR = yes
MPLAYER_NETWORK = yes
STREAMING_LIVE_DOT_COM = yes
NO_MP_MSG = no
endif

# Tools setup

# Robert 2007-11-21 add GCC_VER check, support GCC4.2.1
#GCC_VER = 0304
GCC_VER = 0402


# gcc 4.2.1
ifeq ($(GCC_VER),0402)

ifeq ($(SK2851),yes)
ARC_TOOLS = /usr/local/arc.4.2.1
UCLIBCDIR = $(ARC_TOOLS)/sk885x-2.6/arc-linux-uclibc
else
ARC_TOOLS = /usr/local/arc.4.2.1
#UCLIBCDIR = $(ARC_TOOLS)/linux-2.4/arc-linux-uclibc	#Barry 2008-08-04
UCLIBCDIR = $(ARC_TOOLS)/sk885x-2.4/arc-linux-uclibc
endif

else
ARC_TOOLS = /usr/local/arc
UCLIBCDIR = $(ARC_TOOLS)/arc-linux-uclibc/
endif

GCCDIR = $(ARC_TOOLS)
ifeq ($(SK2851),yes)
MW_DIR = $(ARC_TOOLS)/mw8.1.0/MetaWare/arc
MOD_LIBS = /usr/local/arc.4.2.1/mw8.1.0/MetaWare/arc/lib/a7/le
else
#Barry 2008-08-04
#MW_DIR = $(ARC_TOOLS)/mw8.0.10/MetaWare/arc
#MOD_LIBS = /usr/local/arc.4.2.1/mw8.0.10/MetaWare/arc/lib/a7/le
MW_DIR = $(ARC_TOOLS)/mw8.1.0/MetaWare/arc
MOD_LIBS = /usr/local/arc.4.2.1/mw8.1.0/MetaWare/arc/lib/a7/le
endif
HOST_CC = gcc
#LINUX_DIR=/home/davisonlin/a/linux-2.4.29

# Paths of codec libraries
#MPEG_BASE = $(BASEDIR)/ARC_MPEG_2-4_Decoder/com/arc/software/MPEG_2-4_Decoder/1_0/software_child/
VC1_BASE = VC1_Decoder
H264_BASE = H264_Decoder
AUDIO_CODECS_BASE = libarcaudio

#
ARC_FLAGS = -D__ARC__ -D__ARC_LINUX__ -D__ARC_MPLAYER__ -DARCH_ARC -D__signed__=signed -DCONFIG_ALIGN 
INC = -I$(UCLIBCDIR)/include  -I. -I$(BASEDIR)/Mplayer -I$(BASEDIR)/Mplayer/libvo
ARC_INC =   
ARC_CODECS = 
ARC_CODEC_LIBS = 

ifeq ($(MPLAYER_LITE),yes)
ARC_FLAGS += -DBUILD_MPLAYER_LITE
endif

#Barry 2008-05-09
ifeq ($(SK2851),yes)
ARC_FLAGS += -DBUILD_SK2851
endif

#Raymond 2008/09/03
ifeq ($(NO_MP_MSG),yes)
ARC_FLAGS += -DDISABLE_MP_MSG
endif

ifeq ($(ARC_AURORA),yes)
ARC_FLAGS += -DHAVE_AURORA  -D__ARC_SHARED_BUFFER__ -DARC_BITSTREAM_DMA -DARC_BITSTREAM_READER 
ARC_INC += -Ilibarcavcodec -I../libarcavcodec -I../../libarcavcodec  -I$(MPEG_BASE)/MPEGDecoderLib/
endif

ifeq ($(ARC_H264),yes)
ARC_CODECS += vd_h264.c
ARC_FLAGS += -DBUILD_ARC_H264
ARC_INC += -I$(H264_BASE)/H264DecoderLib -I$(H264_BASE)/H264DecoderLib/H264Decoder
ifeq ($(ARC_AURORA),yes)
ARC_CODEC_LIBS += $(H264_BASE)/H264DecoderLib/libh264dec.a
#ARC_CODEC_LIBS += $(H264_BASE)/libh264dec.a
else
ARC_CODEC_LIBS += /home/peters/build/mplayer/mplayer/libh264unaccel/libh264dec.a 
endif
endif

ifeq ($(ARC_VC1),yes)
ARC_CODECS += vd_msvc1.c
ARC_FLAGS += -DBUILD_ARC_VC1
ARC_INC +=  -I$(VC1_BASE)/VC1DecoderLib -I$(VC1_BASE)/VC1DecoderLib/VC1SIMDDec -I$(VC1_BASE)/VC1DecoderLib/wmv2/decoder_c9/c/
ifeq ($(ARC_AURORA),yes)
ARC_CODEC_LIBS += $(VC1_BASE)/VC1DecoderLib/libvc1dec.a
else
ARC_CODEC_LIBS += /home/philb/vc1/Aurora_Latest/lib/libmsvc1_nosimd.a
endif
endif

ifeq ($(ARC_WMA),yes)
ARC_FLAGS += -DBUILD_ARC_WMA
#ARC_CODEC_LIBS += $(AUDIO_CODECS_BASE)/WMA-Decoder/make/wmaDecoder.lib 
ARC_CODEC_LIBS += $(AUDIO_CODECS_BASE)/WMA-Decoder/make/wmaDecoder.mplayer.lib 
ARC_INC += -I$(AUDIO_CODECS_BASE)/WMA-Decoder/
ARC_AUDIO = yes
endif

ifeq ($(ARC_MP3),yes)
ARC_FLAGS += -DBUILD_ARC_MP3
ARC_CODEC_LIBS += $(AUDIO_CODECS_BASE)/MPEG2-MP3Decoder/make/mp3Decoder.lib
ARC_INC += -I$(AUDIO_CODECS_BASE)/MPEG2-MP3Decoder/
ARC_AUDIO = yes
endif

ifeq ($(ARC_AAC),yes)
ARC_FLAGS += -DBUILD_ARC_AAC
ARC_CODEC_LIBS += $(AUDIO_CODECS_BASE)/MPEG4-AACDecoder/make/xyAacDecoder.lib
ARC_INC += -I$(AUDIO_CODECS_BASE)/MPEG4-AACDecoder/
ARC_AUDIO = yes
endif

# Raymond 2008/08/18
ifeq ($(GUC_JPEG),yes)
ARC_FLAGS += -DHW_JPEG
endif

ifeq ($(ARC_DISPLAY_CENTRING),yes)
ARC_FLAGS += -DALLOW_PGU_CENTERING -DCONFIG_ENABLE_CENTERING
endif

ifeq ($(ARC_DEMO),yes)
#ARC_FLAGS +=  -DARC_MPLAYER_CONTROLS -DARC_OWN_OSD -DENABLE_OSD -DARC_DISPLAY_CROPPING -DCONFIG_ARC_PGU_CROPPING
ARC_FLAGS += -DENABLE_OSD -DARC_DISPLAY_CROPPING -DCONFIG_ARC_PGU_CROPPING
endif

ifeq ($(MPLAYER_NETWORK),yes)
ARC_FLAGS += -DMPLAYER_NETWORK
MPLAYER_NETWORK_LIB = -L$(UCLIBCDIR)/lib $(LIVE_LIBS) -lnsl
endif

ifeq ($(STREAMING_LIVE_DOT_COM),yes)
ARC_FLAGS += -DSTREAMING_LIVE_DOT_COM
LIVE_LIB_DIR = live
LIVE_LIBS = -lstdc++
LIVE_LIBS +=  $(LIVE_LIB_DIR)/liveMedia/libliveMedia.a
LIVE_LIBS += $(LIVE_LIB_DIR)/groupsock/libgroupsock.a
LIVE_LIBS += $(LIVE_LIB_DIR)/UsageEnvironment/libUsageEnvironment.a
LIVE_LIBS += $(LIVE_LIB_DIR)/BasicUsageEnvironment/libBasicUsageEnvironment.a
endif

AR = arac
CC = ccache arc-elf32-gcc
CXX = ccache arc-elf32-g++
ASM_CC = ccache mcc
LD = ldac
AWK = 
RANLIB = arac -s
INSTALL = install
EXTRA_INC =  

STRIPBINARIES = no

ifeq ($(GCC_VER),0402)
#LIBGCC          := $(shell $(CC) $(CFLAGS) --print-libgcc-file-name)

#Barry 2008-08-04
CC = ccache arc-linux-uclibc-gcc
CXX = ccache arc-linux-uclibc-g++
LIBGCC          := $(shell $(CC) $(CFLAGS) --print-libgcc-file-name)
#LIBGCC := /usr/local/arc.4.2.1/sk885x-2.6/lib/gcc/arc-linux-uclibc/4.2.1/libgcc.a
OPTFLAGS = $(ARC_FLAGS) -O2 -mA7 -mno-sdata -mlong-calls -mmixed-code -mno-volatile-cache -ffast-math -frerun-loop-opt -fomit-frame-pointer $(EXTRA_INC) -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 $(INC) 
ASM_CFLAGS = $(ARC_FLAGS)  $(INC) $(EXTRA_INC) -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -DDEFINE_INT64_T -arc700 -O6 -Mb -Xsimd -Xbarrel_shifter -Xlib -Xea -Xmin_max -Xnorm -Xswap -Xmpy -w4 -Dinline=_Inline -Hsdata0 -Hkeepasm
LDFLAGS = -z gnu -Bdemandload -Bpagesize=8192 -Bgrouplib -B define:_start=__start -B define:__preinit_array_start=0 -B define:__preinit_array_end=0
LDFLAGS_SYSLIB = $(UCLIBCDIR)/lib/crt1.o $(UCLIBCDIR)/lib/crti.o $(UCLIBCDIR)/lib/crtn.o $(UCLIBCDIR)/lib/libstdc++.a $(UCLIBCDIR)/lib/libc.a $(UCLIBCDIR)/lib/libm.a $(UCLIBCDIR)/lib/libpthread.a $(LIBGCC) $(MW_DIR)/lib/a7/le/libct.a $(MOD_LIBS)/libcct.a  $(MW_DIR)/lib/a7/le/libmw.a
OPTFLAGS_GCC3 = $(ARC_FLAGS) -O2 -mA7  -mlong-calls -mmixed-code -mno-volatile-cache -ffast-math -frerun-loop-opt -fomit-frame-pointer $(EXTRA_INC) -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 $(INC) 

else

OPTFLAGS = $(ARC_FLAGS) -O2 -mA7 -mlong-calls -mmixed-code -mno-volatile-cache -ffast-math -frerun-loop-opt -fomit-frame-pointer $(EXTRA_INC) -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 $(INC) 
ASM_CFLAGS = $(ARC_FLAGS)  $(INC) $(EXTRA_INC) -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -DDEFINE_INT64_T -arc700 -O6 -Mb -Xsimd -Xbarrel_shifter -Xlib -Xea -Xmin_max -Xnorm -Xswap -Xmpy -w4 -Dinline=_Inline -Hsdata0 -Hkeepasm
LDFLAGS = -z gnu -Bdemandload -Bpagesize=8192 -Bgrouplib -B define:_start=__start -B define:___uClibc_main=__uClibc_main -B define:_uClibc_main=___uClibc_main $(UCLIBCDIR)/lib/crt0.o $(UCLIBCDIR)/lib/crti.o $(UCLIBCDIR)/lib/libstdc++.a $(UCLIBCDIR)/lib/libc.a $(UCLIBCDIR)/lib/libm.a $(UCLIBCDIR)/lib/libpthread.a $(GCCDIR)/lib/gcc/arc-elf32/3.4.5/arc700/libgcc.a $(MW_DIR)/lib/a7/le/libct.a $(MOD_LIBS)/libcct.a  $(MW_DIR)/lib/a7/le/libmw.a
#Barry 2008-02-21
OPTFLAGS_GCC3 = $(ARC_FLAGS) -O2 -mA7  -mlong-calls -mmixed-code -mno-volatile-cache -ffast-math -frerun-loop-opt -fomit-frame-pointer $(EXTRA_INC) -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 $(INC) 

endif



# -------- Generated by configure -----------

LANG = C
LANGUAGES = en
TARGET_OS = elf32
DESTDIR =
prefix = $(DESTDIR)/usr/local
BINDIR = $(DESTDIR)/usr/local/bin
DATADIR = $(DESTDIR)/usr/local/share/mplayer
MANDIR = $(DESTDIR)/usr/local/man
CONFDIR = $(DESTDIR)/usr/local/etc/mplayer
LIBDIR = $(DESTDIR)/usr/local/lib

HELP_FILE = help/help_mp-en.h

PRG = mplayer
PRG_MENCODER = mencoder

DVBIN = no
VIDIX = no
SHARED_PP = no
CONFIG_PP = yes
CONFIG_RISKY = yes
CONFIG_MP3LAME = no
LIBMENU = no
I18NLIBS = 
MATROSKA = no

OPENDIVX = no

MP3LIB = no
LIBMPEG2 = no
TREMOR_FLAGS = 

UNRARLIB = no
HAVE_FFPOSTPROCESS = no
PNG = no
JPEG = no
GIF = no

EXTRA_LIB = 
Z_LIB =   
HAVE_MLIB = no
WIN32_LIB = 
STATIC_LIB = 
ENCA_LIB = 
HAVE_PTHREADS = no
MATH_LIB = 

X11_INC = 
X11DIR = 

HAVE_XVMC_ACCEL = no

# for libavcodec:
SRC_PATH=..
LIBPREF=lib
LIBSUF=.a
SLIBPREF=lib
SLIBSUF=.so

# video output
X_LIB = 
GGI_LIB = 
MLIB_LIB =  
MLIB_INC = 
DXR2_INC = 
DVB_INC = 
PNG_LIB = 
JPEG_LIB = 
GIF_LIB = 
SDL_LIB = 
SVGA_LIB = 
AA_LIB = 
CACA_INC = 
CACA_LIB = 

# audio output
ALSA_LIB = 
NAS_LIB = 
ARTS_LIB = 
ARTS_INC = 
ESD_LIB = 
ESD_INC = 
POLYP_LIB = 
POLYP_INC = 
JACK_LIB = 
JACK_INC = 
SGIAUDIO_LIB = 

# input/demuxer/codecs
TERMCAP_LIB = 
LIRC_LIB = 
LIRCC_LIB = 
DVDREAD_LIB = 
DVDKIT = 
DVDKIT2 =
DVDKIT_SHARED =
SDL_INC = 
W32_DEP = 
W32_LIB = 
DS_DEP = 
DS_LIB = 
ifeq ($(ARC_AURORA),yes)
ifeq ($(MPLAYER_LITE),yes)
AV_DEP = 
AV_LIB = 
ARC_AV_DEP = libarcavcodec/libarcavcodec.a 
ARC_AV_LIB = libarcavcodec/libarcavcodec.a 
else
AV_DEP = libavformat/libavformat.a
AV_LIB = libavformat/libavformat.a
ARC_AV_DEP = libarcavcodec/libarcavcodec.a libavformat/libavformat.a
ARC_AV_LIB = libarcavcodec/libarcavcodec.a libavformat/libavformat.a
endif
#ARC_AV_DEP = libavformat/libavformat.a
#ARC_AV_LIB = libavformat/libavformat.a
else
AV_DEP = libavcodec/libavcodec.a libavformat/libavformat.a
AV_LIB = libavcodec/libavcodec.a libavformat/libavformat.a
endif
#AV_DEP = libavcodec/libavcodec.a libavformat/libavformat.a
#AV_LIB = libavcodec/libavcodec.a libavformat/libavformat.a
CONFIG_LIBAVFORMAT = yes
ZORAN = no
FAME = no
FAME_LIB = 
MP1E_DEP = 
MP1E_LIB = 
ARCH_LIB =   
XVID = no
XVID_INC = 
XVID_LIB = 
X264 = no
X264_INC = 
X264_LIB = 
CONFIG_DTS = 
DTS_INC = 
DTS_LIB = 
DECORE_LIB =  
MENCODER = 
ENCORE_LIB =   
DIRECTFB_INC = 
DIRECTFB_LIB = 
CDPARANOIA_INC = 
CDPARANOIA_LIB = 
FREETYPE_INC = 
FREETYPE_LIB = 
FONTCONFIG_INC =  
FONTCONFIG_LIB =  
FRIBIDI_INC = 
FRIBIDI_LIB = 
LIBLZO_LIB= 
MAD_LIB = 
VORBIS_LIB =  
THEORA_LIB = 
FAAD_LIB = 
INTERNAL_FAAD = no (broken gcc)
SMBSUPPORT_LIB = 
XMMS_PLUGINS = 
XMMS_LIB = 
MACOSX = 
MACOSX_FINDER_SUPPORT =
MACOSX_BUNDLE =
MACOSX_FRAMEWORKS = 
TOOLAME=no
TOOLAME_EXTRAFLAGS=
TOOLAME_LIB= 
AMR_NB_FIXED=no

# --- Some stuff for autoconfigure ----
TARGET_ARCH_X86 = no
TARGET_ARCH_ARC=yes
TARGET_WIN32 = no
TARGET_CPU=arc
TARGET_MMX = no
TARGET_MMX2 = no
TARGET_3DNOW = no
TARGET_3DNOWEX = no
TARGET_SSE = no
TARGET_ALTIVEC = 
TARGET_VIS = 

# --- GUI stuff ---
GTKLIB = 
GLIBLIB = 
GTK_LIBS =   $(GTKLIB) $(GLIBLIB)
GUI = no
DEBUG = -DDEBUG

