#ifdef BUILD_SK2851		//Barry 2008-05-09

#ifndef PGU_LIB_H
#define PGU_LIB_H

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <termios.h>
#include <errno.h>
#include <sys/mman.h>

#include <signal.h>
#include <stdio.h>

//#include <arc_pgu.h>
//#include "libarcavcodec/arc_pgu.h"
#include "libvo/arc_pgu.h"	// Raymond 2007/04/25

#define ENCODE_RGBA5551(r,g,b,a) (((a) << 15) | (((r) >> 3) << 10) | (((g) >> 3) << 5) | ((b) >> 3))
#define ENCODE_RGB555(r,g,b) ((((r) >> 3) << 10) | (((g) >> 3) << 5) | ((b) >> 3))
#define ENCODE_RGBA4444(r,g,b,a) ((((a) >> 4) << 12) | (((r) >> 4) << 8) | (((g) >> 4) << 4) | ((b) >> 4))
#define RGB_555_REDCONTENT(pixel) (((pixel >> 7) & 0xf8))
#define RGB_555_GREENCONTENT(pixel) (((pixel >> 2) & 0xf8))
#define RGB_555_BLUECONTENT(pixel) ((pixel & 0x1f) << 3)

#define ENCODE_SK2851_OSD_DATA(a, r, g, b)	( (a << 7) | (r << 5) | (g << 2) | (b << 0) )		//Barry 2008-07-30

#define NUMBUFS 18
typedef struct {
  volatile void* Y[NUMBUFS];
  volatile void* U[NUMBUFS];
  volatile void* V[NUMBUFS];
} YUV_planes;

extern YUV_planes planes;
//Robert 2007-11-21 Remove yuv extern, fix GCC 4 compile error
//extern struct yuv_info yuv;

extern struct yuv_info mp_yuv;		//Barry 2008-05-09

extern int  pgu_open_fb();
extern void  pgu_close_fb();
extern void  pgu_map_sdm_buffer(void);
extern void  pgu_unmap_sdm_buffer(void);
extern unsigned char*  pgu_map_buffer(int length, int offset);
extern int  pgu_unmap_buffer(unsigned char *ptr, int length);
extern unsigned int  pgu_get_yuv_base(unsigned char bufno);
extern int  pgu_get_yuv_buffers(unsigned char* ptr);
extern int pgu_get_fb_size(void);
int  pgu_set_primary_mode(unsigned long newmode);
extern int pgu_set_origin(unsigned int x, unsigned int y);
extern int  pgu_switch_to_buffer(int bufno);
extern int  pgu_switch_to_user_defined_buffer(struct yuv_info *tmpyuv);
extern int  pgu_set_resolution(unsigned int x, unsigned int y);
extern int  pgu_set_yuv_resolution(unsigned int x, unsigned int y);
extern int  pgu_stop_pgu(void);
extern int  pgu_start_pgu(void);
extern int pgu_set_primary_buffer(unsigned long bufno);

//Barry 2008-06-18
int pgu_enable_osd(unsigned long _en);
int pgu_select_osd(unsigned long _idx, unsigned long _en);
int pgu_set_osd_start_position(unsigned long _idx, unsigned long _x, unsigned long _y);
int pgu_set_osd_end_position(unsigned long _idx, unsigned long _x, unsigned long _y);

int  audio_pgu_get_yuv_buffers();		//Barry 2008-06-20

#if 0	//Barry 2008-08-18
extern int  pgu_reset(void);
int  pgu_open_fb_for_time();
void  pgu_close_fb_for_time();
void set_mplayer_time(int mplayer_time);

// Raymond 2007/08/23
void set_mplayer_duration(int mplayer_duration);

// Raymond 2008/05/20
void set_mplayer_status(int _status);
//Barry 2007-12-24
int pgu_show_mplayer_time(char _time[]);
int pgu_clear_mplayer_time(void);
//Barry 2007-08-20	AVI with subtitle
int pgu_get_display_index();
int pgu_show_mplayer_subtitle(char _s[][31]);
int pgu_clear_mplayer_subtitle();
int pgu_enable_tv_osd(int yesno);
//-- Flowbee 2008-03-37
extern int pgu_set_video_yuv_res(struct _disp_scalar_info *p);
#endif

#endif


#else	//SK2850


#ifndef PGU_LIB_H
#define PGU_LIB_H

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <termios.h>
#include <errno.h>
#include <sys/mman.h>

#include <signal.h>
#include <stdio.h>

//#include <arc_pgu.h>
#include "libvo/arc_pgu.h"	// Raymond 2007/05/21

#define ENCODE_RGBA5551(r,g,b,a) (((a) << 15) | (((r) >> 3) << 10) | (((g) >> 3) << 5) | ((b) >> 3))
#define ENCODE_RGB555(r,g,b) ((((r) >> 3) << 10) | (((g) >> 3) << 5) | ((b) >> 3))
#define ENCODE_RGBA4444(r,g,b,a) ((((a) >> 4) << 12) | (((r) >> 4) << 8) | (((g) >> 4) << 4) | ((b) >> 4))
#define RGB_555_REDCONTENT(pixel) (((pixel >> 7) & 0xf8))
#define RGB_555_GREENCONTENT(pixel) (((pixel >> 2) & 0xf8))
#define RGB_555_BLUECONTENT(pixel) ((pixel & 0x1f) << 3)

#define NUMBUFS 18
typedef struct {
  volatile void* Y[NUMBUFS];
  volatile void* U[NUMBUFS];
  volatile void* V[NUMBUFS];
} YUV_planes;

extern YUV_planes planes;
//Robert 2007-11-21 Remove yuv extern, fix GCC 4 compile error
//extern struct yuv_info yuv;

extern struct yuv_info mp_yuv;		//Barry 2008-05-09

int pgu_mask_and_set_statctrl(unsigned long mask, unsigned long newbits);
int pgu_get_statctrl(unsigned long *dest);

//Barry 2007-08-20	AVI with subtitle
int pgu_get_display_index();
int pgu_show_mplayer_subtitle(char _s[][31]);
int pgu_clear_mplayer_subtitle();
int pgu_enable_tv_osd(int yesno);

int  pgu_open_fb();
void  pgu_close_fb();
unsigned char*  pgu_map_buffer(int length, int offset);
int  pgu_unmap_buffer(unsigned char *ptr, int length);
unsigned int  pgu_get_yuv_base(unsigned char bufno);
//int  pgu_get_yuv_buffers(unsigned char* ptr);		//Barry 2008-07-30
int  pgu_set_primary_mode(int newmode);
int  pgu_set_overlay_mode(int newmode);
int  pgu_enable_overlay(int yesno);
int  pgu_set_resolution(unsigned int x, unsigned int y);
int  pgu_set_yuv_resolution(unsigned int x, unsigned int y);
void  pgu_display_controller();
int  pgu_switch_to_buffer(int bufno);
arc_pgu*  pgu_get_pgu();
int  pgu_set_pgu(arc_pgu* newpgu);
int  pgu_reset();
int  pgu_stop_pgu();
int  pgu_start_pgu();
int  pgu_get_colkey(unsigned long *dest);
int  pgu_set_colkey(unsigned long newkey);
int  pgu_set_ol_startend(int start, int end);
unsigned long  pgu_set_clkcfg(unsigned long pxlclk, unsigned long sysclk);
int pgu_set_ol_offset(unsigned long offset);
int pgu_set_origin(unsigned int x, unsigned int y);
int pgu_set_primary_buffer(unsigned long bufno);
void pgu_blank_rgb(unsigned long base_offset, int width, int height);
void  pgu_dump_controller_regs(arc_pgu *pguptr);
int get_hsync_cycle(arc_pgu* tmppgu);
int get_hsync_backporch(arc_pgu* tmppgu);
int get_hsync_width(arc_pgu* tmppgu);
unsigned long set_hsync(int cycle, int backporch, int width);
int get_vsync_cycle(arc_pgu* tmppgu);
int get_vsync_backporch(arc_pgu* tmppgu);
int get_vsync_width(arc_pgu* tmppgu);
unsigned long set_vsync(int cycle, int backporch, int width);

// Raymond 2007/08/08

int  pgu_open_fb_for_time();
void  pgu_close_fb_for_time();
void set_mplayer_time(int mplayer_time);

// Raymond 2007/08/23
void set_mplayer_duration(int mplayer_duration);

// Raymond 2008/05/20
void set_mplayer_status(int _status);

#if 0	//Barry 2008-08-18
//Barry 2007-12-24
int pgu_show_mplayer_time(char _time[]);
int pgu_clear_mplayer_time(void);
#endif
//int  audio_pgu_get_yuv_buffers();		//Barry 2008-06-20
int  pgu_get_yuv_buffers();		//Barry 2008-07-30
#endif

#endif	//SK2850
