// vd_h264.c

#include <stdio.h>
#include <string.h>
#include <signal.h>

#include <fcntl.h>
#include <sys/mman.h>
#include <errno.h>


#include "vd_internal.h"
#include "../libvo/arc_pgu.h"
//#include "H264Decoder.h"
#include "arc_codecs.h"

#include <sys/mman.h>
#include <sys/types.h>

//static int InitOutput (void);
static void transmit (char *data,int sz);

//create the interface structure for this codec
//which contains pointers to the info struct above, and all below functions
//init, uninit, control, decode (in that order)
static vd_info_t info = {
  "H.264 Decoder", 	// codec long name
  "h264",		// codec short name (driver name in codecs.conf)
  "pbb",		// maintainer
  "pbb",		// author
  "test"		// additional comments
};
LIBVD_EXTERN(h264)

extern volatile void *memBase0;	//quick hack to get access to the virtual base address

//global static variables
static unsigned long *virtualBufferAddresses;
static unsigned long *physicalBufferAddresses;
static mp_image_t *get_next_frame (sh_video_t *);
static int initialised = 0;
static vd_frameinfo_t frameInfo = {0, NULL,get_next_frame};
static int fdMem = -1;
static void *SDM_StartAddr = (void *)-1;
static int waitForIDR = 0;
static sh_video_t *sh_ptr = NULL;
static arc_frame_data frameData;
static int flushedOutput = 0;
static mp_image_t *CreateMpiImage (sh_video_t *);

unsigned long g_NALsize = 0;
unsigned long g_NALLenDec = 0;

// Raymond
static int fdFrameDevice = -1;
static unsigned long *vDecBuffer;	// virtual
static unsigned long *pDecBuffer;	// physical

extern int display_frame;	//for scalar Barry 2007-05-11

extern int speed_mult;	//Barry 2007-10-22

static void SetSizes (unsigned long, unsigned long,int);
static int InitOutput (int);

#define BE_16(x) (((unsigned char *)(x))[0] <<  8 | \
		  ((unsigned char *)(x))[1])
#define BE_24(x) (((unsigned char *)(x))[0] << 16 | \
		  ((unsigned char *)(x))[1] <<  8 | \
		  ((unsigned char *)(x))[2])
#define BE_32(x) (((unsigned char *)(x))[0] << 24 | \
		  ((unsigned char *)(x))[1] << 16 | \
		  ((unsigned char *)(x))[2] <<  8 | \
		  ((unsigned char *)(x))[3])

/******************************************************************************
   Access to the external function interface structure
******************************************************************************/
extern arc_codec_functions h264_functions;

#include "libarcavcodec/arc/aurora_asm.h"
#include "libvo/video_out.h"		// Raymond - for HW scalar

static int fb_addr_to_index(void *vaddr)
{
    int i;
    for (i=0; virtualBufferAddresses[i] != (unsigned)vaddr; i++);

    return i;
}

static int fb_dec_addr_to_index(void *vaddr)
{
    int i;
    for (i=0; vDecBuffer[i] != (unsigned)vaddr; i++);

    return i;
}

static void SetSizes (unsigned long w, unsigned long h, int num_buffers)
{
  int i;
  //check for initialisation
  if (initialised == 0)
  {
    // Raymond 2007/05/09
    if ( get_preview == 0 )
    	fprintf(stderr,"\nInitialising display: %u:%u with %u buffers\n",w,h,num_buffers);    

/*     if (sh_ptr->disp_w < w) sh_ptr->disp_w = w; */
/*     if (sh_ptr->disp_h < h) sh_ptr->disp_h = h; */

    mpcodecs_config_vo(sh_ptr,w,h,IMGFMT_YV12); //YUV420 format

	// Set decoder buffer resolution - Raymond 2007/03/16
	if( use_DecBuffer == 1 )
		SetDecBufferResolution(w, h);	
	
#if defined __ARC_SHARED_BUFFER__
    //set the addresses of all buffers
    if (!InitOutput(num_buffers))
      return;
#endif
    initialised = 1;
  }
}

// Raymond 2007/03/22 - fixed by barry
int CurrIndex = -1;

int drop_flags = 0;	// Raymond 2007/03/22

// get the next frame from the saved image buffer (if present)
// form a mplayer image buffer and fill it with the data
// then update the structure for the remaining frames (if any)
static mp_image_t *get_next_frame (sh_video_t *sh)
{
	mp_image_t *mpi = NULL;
	//check that there are frames left
	if (frameInfo.numFrames == 0)
		return (NULL);
	frameInfo.numFrames--;
	
	//get an image buffer to copy the frame data to
	mpi = CreateMpiImage (sh);

#if 0	//for scalar Barry 2007-05-11
	// Raymond - for HW scalar , 2006/10/31
	if( ( HW_Scalar == 1 ) && get_preview == 0 && ( ( mpi->w != DispX ) || ( mpi->h != DispY)  ) )
	{		
		int w = mpi->w;
		int h = mpi->h;
		int outx, outy, image_size;
		unsigned int YAddr, UAddr, VAddr;
		unsigned int Yout, Uout, Vout;
		unsigned char *plane[3] = {NULL,NULL,NULL};
		int a = fb_dec_addr_to_index(mpi->planes[0]);

		// Raymond 2007/03/22 - fixed by barry
		if( CurrIndex >= 0 )
			vbuf_dec_free(CurrIndex);

		CurrIndex = a;
		
		//
		if(!drop_flags)	// Raymond 2007/03/22
		{
		int b = vbuf_scale_alloc();

		// Raymond fix bug - 2006/11/17
		if ( w & 0xf) 
			w = ((w + 0xf) & ~0xf);	
		// Raymond 2006/12/26
//		if (h & 0xf)
//			h = ((h + 0xf) & ~0xf);

		// Raymond 2007/04/26
		// scale buffer
		plane[0] = (unsigned char *)get_bufN_Y(b);
		plane[1] = (unsigned char *)get_bufN_U(b);
		plane[2] = (unsigned char *)get_bufN_V(b);

		Yout = VIRTUAL_TO_FB(plane[0]);
		Uout = VIRTUAL_TO_FB(plane[1]);
		Vout = VIRTUAL_TO_FB(plane[2]);		

		YAddr = VIRTUAL_TO_FB(mpi->planes[0]);
		UAddr = VIRTUAL_TO_FB(mpi->planes[1]);
		VAddr = VIRTUAL_TO_FB(mpi->planes[2]);

		ScaleFrame(YAddr, UAddr, VAddr, Yout, Uout, Vout, a, b);

#if 0	
		// Original w x h
		FILE *yuv_out1 = fopen("out1.yuv","ab");
		if( yuv_out1 == NULL )
			return 0;
		fwrite( (unsigned char *)mpi->planes[0], 1, w * h, yuv_out1);
		fwrite( (unsigned char *)mpi->planes[1], 1, w * h/4, yuv_out1);
		fwrite( (unsigned char *)mpi->planes[2], 1, w * h/4, yuv_out1);
		fclose(yuv_out1);
		
		// after scale to DispX x DispY
		FILE *yuv_out2 = fopen("out2.yuv","ab");
		if( yuv_out2 == NULL )
			return 0;
		fwrite( (unsigned char *)plane[0], 1, image_size, yuv_out2);
		fwrite( (unsigned char *)plane[1], 1, image_size/4, yuv_out2);
		fwrite( (unsigned char *)plane[2], 1, image_size/4, yuv_out2);
		fclose(yuv_out2);
		
#endif
		vbuf_scale_send(b);
      		vbuf_scale_free(b);
		}	
	}	
#else
	//for scalar Barry 2007-05-11
	if( HW_Scalar == 1 )
	{
		int a = fb_dec_addr_to_index(mpi->planes[0]);

		// Raymond 2007/03/22 - fixed by barry
		if( CurrIndex >= 0)
			vbuf_dec_free(CurrIndex);

		CurrIndex = a;
		
		//if(!drop_flags)	// Raymond 2007/03/22
		if((!drop_flags) || (speed_mult != 0))	//Barry 2007-10-22
		{
			int i = 0;
			if (display_frame == 0)	//Barry 2007-05-10
				vbuf_scalar_start(a);
			else{
				while( (i = vbuf_scalar_status()) != SCALAR_IDLE) 
					usleep(1);
				vbuf_scalar_start(a);
			}
		}	
	}	
#endif	
//	else 
	else if( get_preview == 1 )	// Raymond 2007/03/20	
	{
		vbuf_dec_free(fb_dec_addr_to_index(mpi->planes[0]));	
	}
	else
	{
		int a = fb_addr_to_index(mpi->planes[0]);
//		printf("H264 vbuf_send : %d\n", a);
	 	vbuf_send(a);
      		vbuf_free(a);
	}

	return (mpi);
}

static int control (sh_video_t *sh, int cmd, void *arg, ...)
{
  if (cmd == VDCTRL_RESYNC_STREAM)
    frameInfo.numFrames = 0;
  return (h264_functions.control(cmd,arg));
}

static int init (sh_video_t *sh)
{
  int i = 0;
  short s;
  unsigned long physaddr;
  struct yuv_info yuv;
//  fprintf(stderr,"\nInit:\n");

  flushedOutput = 0;
  h264_functions.set_sizes = (fp_set_sizes)SetSizes;
  memset(&frameData,0,sizeof(arc_frame_data));
        

  fdMem = -1;
  //open a memory device to get access to the SDM memory
  fdMem = open("/dev/mem",O_RDWR|O_SYNC);
  if (fdMem < 0)
  {
    fprintf(stderr,"\nFailed to open /dev/mem");
    return (0);
  }
  SDM_StartAddr = mmap((void *)0,32768,PROT_READ|PROT_WRITE,MAP_SHARED,fdMem,0xC0F00000);
  if (SDM_StartAddr == (void *)-1)
  {
    fprintf(stderr,"\nFailed on mmap [%s]",strerror(errno));
    return (0);
  }

	// Raymond 2004/04/16
	if( HW_Scalar == 1 )
	{  		
		int ret = InitPhyMem(fdMem);
		if (ret == 0)
      		{
       		fprintf(stderr,"\nFailed on InitPhyMem [%s]",  strerror(errno));
        		return (0);
      		}	
	}
  
//  fprintf(stderr,"\nMapped address is 0x%.8X",SDM_StartAddr);
  if (!h264_functions.set_buffer_addresses((unsigned long)SDM_StartAddr,NULL,NULL) ||
      !h264_functions.init (ARC_H264,NULL,0,0,0,0))
  {
    fprintf(stderr,"\nFailed to construct the decoder");
    return (0);
  }
  mpcodecs_vd_h264.frameInfo = &frameInfo;
  sh_ptr = sh;
  initialised = 0;

  sh->ds->demuxer->isH264 = 1;

  return (1);
}

static void uninit (sh_video_t *sh)
{
  int i;
  h264_functions.uninit();
  if (SDM_StartAddr != (void *)-1)
    munmap(SDM_StartAddr,32768);

  // Raymond 2004/04/16
  if( HW_Scalar == 1 )
    ClosePhyMem();	
  
  if (fdMem >= 0)
    close(fdMem);
  if (virtualBufferAddresses) 
      free(virtualBufferAddresses);
  if (physicalBufferAddresses)
      free(physicalBufferAddresses);
}

// Based on demux_mov.c
static int decode_avc1_hdr(sh_video_t *sh, void *data, int len, int flags)
{
  int cnt, result, declen, numframes, poffs, i;
  unsigned char *input = (unsigned char *)data;
  struct demuxer_st *demuxer = sh->ds->demuxer;

  demuxer->headerConsumed = 1;

  // Are we sane?
  if (*(input) != 1)
    fprintf(stderr, "H264: unknown avcC version (%d).\n", *(input));
  if ((*(input+1)) != 66) 
    fprintf(stderr, "H264: stream header indicates AVC stream is not baseline profile (profile_idc = %d)\n", *(input+1));

  // Number of bytes per NAL
  demuxer->nalLengthLen = ((*(input+4))&0x03)+1;
  // Number of SPS's
  cnt = (*(input+5) & 0x1f);
  poffs = 6;
  // SPS processing
  for (i = 0; i < cnt; i++) {
    declen = BE_16(input+poffs);
    if ((result = h264_functions.decode(&input[poffs+2],declen,0,&numframes, flags)) < 0)
    {
      fprintf(stderr,"\nSPS decode failed, return code is %d\n",result);
      return -1;
    }
    if (numframes > 0)
      frameInfo.numFrames += numframes;
    poffs += declen + 2;
  }

  // Number of PPS's
  cnt = *(input+poffs);
  poffs++;
  // PPS processing
  for (i = 0; i < cnt; i++) {
    declen = BE_16(input+poffs);
    if ((result = h264_functions.decode(&input[poffs+2],declen,0,&numframes, flags)) < 0)
    {
      fprintf(stderr,"\nPPS decode failed, return code is %d\n",result);
      return -1;
    }
    if (numframes > 0)
      frameInfo.numFrames += numframes;
    poffs += declen + 2;
  }

  return 0;
}


// Length-based NAL parsing for AVC1 format
static mp_image_t *decode_avc1(sh_video_t *sh, void *data, int len, int flags)
{
  int i,j,numframes = 0;
  int result;
  unsigned char *input = (unsigned char *)data;
  int index = 0;
  int startIndex = -1;
  int endIndex = -1;
  mp_image_t *mpi = NULL;
  struct demuxer_st *demuxer = sh->ds->demuxer;
  int decptr = 0;
  int origlen = len;

  while (len > 0)
  {
    int declen;

    switch(demuxer->nalLengthLen)
    {
      case 1:
	declen = ((unsigned char*)data)[decptr];
	decptr += 1;
	break;
      case 2:
	declen = BE_16(data+decptr);
	decptr += 2;
	break;
      case 4:
	declen = BE_32(data+decptr);
	decptr += 4;
	break;
      default:
	// Standard says NAL length will only be 1,2 or 4.
	fprintf(stderr,"Unexpected NAL length value %d\n",demuxer->nalLengthLen);
	break;
    }

    if (decptr+declen > origlen) {
      //fprintf(stderr,"****** Can\'t fully decode this NAL %d + %d > %d \n ******", decptr, declen, len);
      break;
    }

    g_NALsize = declen;
    g_NALLenDec = 1;

    if ((result = h264_functions.decode(&input[decptr],declen,0,&numframes,flags)) < 0)
    {
      fprintf(stderr,"\nDecode failed, return code is %d\n",result);
      return (NULL);
    }
    //check the number of decoded frames
    if (numframes > 0)
      frameInfo.numFrames += numframes;
    decptr += declen;
    len -= declen;
  }

  mpi = get_next_frame(sh);  
  return (mpi);  
}

static mp_image_t *decode (sh_video_t *sh, void *data, int len, int flags)
{
  int i,numframes = 0;
  int result;
  //fprintf(stderr,"\nIn the H.264 codec\n\n");
  unsigned char *input = (unsigned char *)data;
  //split down into individual NAL payloads
  int index = 0;
  int startIndex = -1;
  int endIndex = -1;
  int zeros = 0;
  mp_image_t *mpi = NULL;
  struct demuxer_st *demuxer = sh->ds->demuxer;

	drop_flags = flags;	// Raymond 2007/03/22

  //check the length, if -ve, insert a dummy payload
  if (len >= 0)
  {
    int numNals = demuxer->numNalOffsets+1;

    // Check if we're doing length based parsing (MOV/MP4, Some MPEG TS, and doubtless others....)
    if (sh->format == mmioFOURCC('a', 'v', 'c', '1'))
    {
      if (! demuxer->headerConsumed) 
	decode_avc1_hdr(sh,(((unsigned char*)sh->bih)+40),sh->bih->biSize,flags);
      return decode_avc1(sh, data, len, flags);
    }

    if (((demuxer->file_format == DEMUXER_TYPE_RTP) || (demuxer->file_format == DEMUXER_TYPE_MPEG_TS))
	&& ((len >= 4) && (input[0] == 0) && (input[1] == 0) && (input[2] == 1)))
    {
      //need to find NALs in the provided data
      unsigned long value = 0x000000FF;
      //find the starter of a NAL
      int nalCount = 0;
      for (i=3; i<len; i++)
      {
        value <<= 8;
        value |= input[i];
        if ((value & 0x00FFFFFF) == 0x00000001)
	{
          if (nalCount == 0)   // Check !! was !=
	  {
            demuxer->nalOffsets = (int *)malloc(sizeof(int));
	    //            demuxer->nalOffsets[0] = i-3;
            demuxer->nalOffsets[0] = i-2;
            demuxer->numNalOffsets = 1;
          }
          else
	  {
            int j;
            int *tmp = (int *)malloc((demuxer->numNalOffsets+1) * sizeof(int));
            for (j=0; j<demuxer->numNalOffsets;j++)
              tmp[j] = demuxer->nalOffsets[j];
            free(demuxer->nalOffsets);
            demuxer->nalOffsets = tmp;
            demuxer->nalOffsets[demuxer->numNalOffsets++] = i-2;
          }
          //found a start of a NAL
          nalCount++;
        }
      }
      numNals += nalCount;
    }
    if (numNals == 1)
    {
      //only one NAL, the offset is 3 into the buffer to allow for 0,0,0,1
      if ((len >= 4) && (input[0] == 0) && (input[1] == 0) && (input[2] == 1))
      {
	result = h264_functions.decode(&input[3],len-3,0,&numframes, flags);
      }
      else
      {
	result = h264_functions.decode(input,len,0,&numframes, flags);
      }
      if (result < 0)
      {
        fprintf(stderr,"\nDecode failed, return code is %d\n",result);
        return (NULL);
      }
      //check the number of decoded frames
      if (numframes > 0)
        frameInfo.numFrames += numframes;
    }
    else
    {
      int i,j,incvalue;
      //multiple NALs
      startIndex = 3;
      for (i=0; i<numNals;i++)
      {
        incvalue = 0;
        if (i != (numNals-1))
	{
	  endIndex = demuxer->nalOffsets[i];
          if (input[endIndex-1] == 0)
	  {
            endIndex--;
            incvalue = 1;
	  }
        }
	else
	  endIndex = len;
        result = h264_functions.decode(&input[startIndex],endIndex-startIndex,0,&numframes, flags);
        if (result < 0)
        {
          fprintf(stderr,"\nDecode failed, return code is %d\n",result);
          return (NULL);
        }
        //check the number of decoded frames
        if (numframes > 0)
          frameInfo.numFrames += numframes;
        startIndex = endIndex + 3 + incvalue;
      }
      //clear the offset data
      demuxer->numNalOffsets = 0;
      free(demuxer->nalOffsets);
      demuxer->nalOffsets = NULL;
    }
  }
  else //if len is -ve insert a dummy payload to flush remaining frames
  {
    if (flushedOutput == 0)
    {
      //flush any remaining frames
      unsigned char endstream[1] = {11};
      unsigned char *udata = (unsigned char *)endstream;
      flushedOutput = 1;
      result = h264_functions.decode(endstream,1,0,&numframes, flags);
      if (result >= 0)
      {
        //check the number of decoded frames
        if (numframes > 0)
          frameInfo.numFrames += numframes;
      }
    }
    //otherwise the codec has already decoded a flush stream header, but there may be some more frames...
  }
  //if (numframes > 1)
  //  fprintf(stderr,"\nGetNextFrame (%u)\n",frameInfo.numFrames);
  mpi = get_next_frame(sh);  
  return (mpi);
}


static mp_image_t *CreateMpiImage (sh_video_t *sh)
{

  mp_image_t * mpi = NULL;
#if defined __ARC_SHARED_BUFFER__
  mpi = (mp_image_t *)malloc(sizeof(mp_image_t));
  if (mpi == NULL)
  {
    fprintf(stderr,"\nFailed in Malloc for mpi");
    return (NULL);
  }
  memset(mpi,0,sizeof(mp_image_t));
  h264_functions.get_frame_data(&frameData);
  mpi->flags = MP_IMGFLAG_DIRECT | MP_IMGFLAG_PLANAR | MP_IMGFLAG_YUV;
  mpi->width = sh->disp_w;
  mpi->height = sh->disp_h;
  mpi->w = frameData.width;
  mpi->h = frameData.height;
  mpi->x = frameData.xOffset;
  mpi->y = frameData.yOffset;
  mpi->stride[0] = frameData.stride[0];
  mpi->stride[1] = frameData.stride[1];
  mpi->stride[2] = frameData.stride[2];
  mpi->planes[0] = frameData.planes[0];
  mpi->planes[1] = frameData.planes[1];
  mpi->planes[2] = frameData.planes[2];
  mpi->num_planes = 3;
  mpi->priv = (void *)frameData.index;
  //fprintf(stderr,"\nY: 0x%.8X, U: 0x%.8X,V: 0x%.8X",mpi->planes[0],mpi->planes[1],mpi->planes[2]);
#else
  mpi = mpcodecs_get_image(sh,MP_IMGTYPE_TEMP,(MP_IMGFLAG_PLANAR | MP_IMGFLAG_YUV), sh->disp_w, sh->disp_h);
  f_h264_copy_data(picture,mpi->planes[0]);
#endif

  //fprintf(stderr,"\nsh disp_w %u disp_h %u",sh->disp_w,sh->disp_h);

  return (mpi);
}

#if defined __ARC_SHARED_BUFFER__

// Raymond 2007/03/14
static int InitDecBuffer (int numBuffers)
{
  int i;
  short s;
  unsigned long physaddr;
  struct yuv_info yuv;
  
  //get the YUV buffer information  
  if (ioctl(fdFrameDevice, ARCPGUFB_GET_DEC_YUV, &yuv) == -1)
  {
    fprintf(stderr,"\nH264: ARCPGUFB_GET_DEC_YUV ioctl failed due to %s", strerror(errno));
    return (0);
  }

//  printf("InitDecBuffer() : %d x %d\n", yuv.width, yuv.height);
  
  //and the related physical address information
  physaddr = yuv.phys_base;
  // fprintf(stderr,"\nPhysical base is 0x%X",physaddr);
  //check the number of buffers is correct
  if (yuv.num_buffers < numBuffers)
  {
    fprintf(stderr,"\nH264: Number of driver dec buffers (%u) < %u",yuv.num_buffers,numBuffers);
    return (0);
  }
  //calculate the start addresses of all buffers
  vDecBuffer = malloc((yuv.num_buffers+1) * sizeof(long));
  pDecBuffer = malloc((yuv.num_buffers+1) * sizeof(long));
  for (i=0; i <yuv.num_buffers; i++)
  {
    int offset = ioctl(fdFrameDevice, ARCPGUFB_GET_DEC_YUV_BASE, i);
    vDecBuffer[i] = (unsigned long)memBase0 + offset;
    pDecBuffer[i] = physaddr + offset;
    //fprintf(stderr,"\nVirtual: 0x%.8X, Physical: 0x%.8X",virtualBufferAddresses[i],physicalBufferAddresses[i]);
  }
  //set the tail data (used for range checking)
  vDecBuffer[yuv.num_buffers] = vDecBuffer[yuv.num_buffers-1] + yuv.yuv_size;
  pDecBuffer[yuv.num_buffers] = pDecBuffer[yuv.num_buffers-1] + yuv.yuv_size;

  // Raymond 2007/05/09
  if ( get_preview == 0 )
  	printf("InitDecBuffer() : %d x %d , number = %d\n", yuv.width, yuv.height, yuv.num_buffers);
  
  return (1);
}

static int InitOutput (int numBuffers)
{
  int i;
  short s;
  unsigned long physaddr;
  struct yuv_info yuv;
  //get the YUV buffer information
  fdFrameDevice = open("/dev/fb0",O_RDWR);
  if (fdFrameDevice == -1)
  {
    fprintf(stderr,"arcpgufb: can't open /dev/fb0: %s\n", strerror(errno));
    return -1;
  }
  if (ioctl(fdFrameDevice, ARCPGUFB_GETYUV, &yuv) == -1)
  {
    fprintf(stderr,"\nH264: ARCPGUFB_GETYUV ioctl failed due to %s", strerror(errno));
    return (0);
  }
  //and the related physical address information
  physaddr = yuv.phys_base;
  // fprintf(stderr,"\nPhysical base is 0x%X",physaddr);
  //check the number of buffers is correct
  
  // Raymond 2007/05/08
  if ( use_DecBuffer == 0 )
  if (yuv.num_buffers < numBuffers)
  {
    fprintf(stderr,"\nH264: Number of driver buffers (%u) < %u",yuv.num_buffers,numBuffers);
    return (0);
  }
  //calculate the start addresses of all buffers
  virtualBufferAddresses = malloc((yuv.num_buffers+1) * sizeof(long));
  physicalBufferAddresses = malloc((yuv.num_buffers+1) * sizeof(long));
  for (i=0; i <yuv.num_buffers; i++)
  {
    int offset = ioctl(fdFrameDevice, ARCPGUFB_GET_YUV_BASE, i);
    virtualBufferAddresses[i] = (unsigned long)memBase0 + offset;
    physicalBufferAddresses[i] = physaddr + offset;
    //fprintf(stderr,"\nVirtual: 0x%.8X, Physical: 0x%.8X",virtualBufferAddresses[i],physicalBufferAddresses[i]);
  }
  //set the tail data (used for range checking)
  virtualBufferAddresses[yuv.num_buffers] = virtualBufferAddresses[yuv.num_buffers-1] + yuv.yuv_size;
  physicalBufferAddresses[yuv.num_buffers] = physicalBufferAddresses[yuv.num_buffers-1] + yuv.yuv_size;

  // Raymond 2007/05/09
  if ( get_preview == 0 )
  	printf("InitOutput() : %d x %d , number = %d\n", yuv.width, yuv.height, yuv.num_buffers);
  
#if 1
  // Raymond 2007/03/16
  if ( use_DecBuffer == 1 )
  {
	InitDecBuffer (numBuffers);
	//initialise the codec memory controller
  	h264_functions.set_buffer_addresses((unsigned long)SDM_StartAddr, vDecBuffer, pDecBuffer);
  }	
  else
#endif  	
	//initialise the codec memory controller
	h264_functions.set_buffer_addresses((unsigned long)SDM_StartAddr,virtualBufferAddresses,physicalBufferAddresses);
  
  close(fdFrameDevice);
  return (1);
}

#endif

