

// Types for Demo OSD 

// FIXME This is a mess - need to split out mplayer visible stuff, and package that into mplayer's libvo

#ifndef OSD_TYPES_H
#define OSD_TYPES_H

#include <defns.h>

typedef struct {
  int width, height, bpp;
  screen_mode mode;
} screen_info;

typedef struct {
  unsigned long xmin, ymin;
  unsigned long width, height;
} rectangle;

typedef struct {  
  unsigned int width;
  unsigned int height;
  unsigned int bytes_per_pixel; /* 3:RGB, 4:RGBA */ 
  void (*load)(void* this, unsigned char* dest, rectangle* bounds);
  unsigned char* (*get_pixel)(void* this, unsigned short x, unsigned short y);
} image_desc;

typedef struct {
  image_desc base;
  unsigned short colkey;
  unsigned char trans;
  unsigned char pixel_data[640 * 480 * 3];
} gimp_bitmap;

typedef struct {                            // A screen layout template
  char *name;
  image_desc **images;
  image_desc *mask;
  rectangle* areas[MAX_AREA];
} look_and_feel;

typedef struct {
  char *name;
  int (*init)();
  int (*shutdown)();
  int (*poll_event)();
  int (*handle_event)(int event);
} state_machine;

typedef struct {
  char *path;
  int owns_gui;
  unsigned long gui_main_mode;
  unsigned long gui_ol_mode;
  unsigned long width;
  unsigned long height;
  unsigned long gui_ol_start;
  unsigned long gui_ol_end;
  char** argv;
  char** envp;
} child_program;

typedef struct {                            // Shared state about current setup
  rectangle *regions;
  unsigned long **offsets;
  int start_line, halfway_line, end_line;
  int num_buffers;
} overlay_info;

typedef struct {
  int locked;
  unsigned long offset;
  int blank;
} buffer_ctrl;

typedef struct {
  overlay_info ol_info;
  int num_avail_buffers;
  int show_basic_info;
  int show_static_info;
  buffer_ctrl buffer_states[MAX_RGB_BUFFER];
  int current_buf0;
  int current_buf1;
  int currently_displayed;                   // 0 or 1
  rectangle areas[MAX_AREA];
} osd_state;

#endif
