/*
      //------------------------------------------------------------------------
      //
      //                  S K Y M E D I   P R O P R I E T A R Y
      //
      //          COPYRIGHT (c)   2007 BY SKYMEDI CORPORATION TAIWAN.
      //                   --  ALL RIGHTS RESERVED  --
      //       SKYMEDI Confidential; Need to Know only.
      //       Protected as an unpublished work.
      //
      //       The computer program listings, specifications and documentation
      //       herein are the property of SKYMEDI CORPORATION and shall not be
      //       reproduced, copied, disclosed, or used in whole or in part for
      //       any reason without the prior express written permission of
      //       SKYMEDI CORPORATION.
      //
      //          File Name:        skysyscalls.c
      //
      //          Author:           Jinn
      //
      //          Created:          2, June 2008
      //
      //          Revision:         1.00
      //
      //------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/mman.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <time.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>
#include <errno.h>
#include <signal.h>

#define __SKYSYSCALL_C__

#include "skysyscalls.h"

/* 
 * Implement
 */
_syscall0(unsigned int, get_ir_val);
_syscall1(unsigned int, set_ir_status, unsigned int, _iType);
_syscall1(unsigned int, u32_readphy, volatile unsigned int*, _iPhyAdd);
_syscall2(unsigned int, u32_writephy, volatile unsigned int*, _iPhyAdd, unsigned int, _iVal );
_syscall2(unsigned int, bit_readphy, volatile unsigned int*, _iPhyAdd, unsigned int, _iMask );
_syscall3(unsigned int, bit_writephy, volatile unsigned int*, _iPhyAdd, unsigned int, _iMask, unsigned int, _iVal );
_syscall3(unsigned int, exchange_msg, unsigned int, _iCmd, unsigned int*, _piData, unsigned int, _iType );
_syscall5(unsigned int, skydma, unsigned int, _iChannel, unsigned int, _iDest, unsigned int, _iSrc, unsigned int, _iLength, unsigned int, _iDebug );

#if 0 /* sample code */
void _DMA_SAMPLE_CODE( void ) {

     unsigned int _iDest   = 0x12345600;
     unsigned int _iSrc    = 0x87654300;
     unsigned int _iLength = 0x1000;
     
     if( _iLength == skydma( DMA_CH2, _iDest, _iSrc, _iLength, PRINT_DEBUG_MESSAGE ) ) {
          // dma copy ok
     }
     else {
          MEMCPY( _iDest, _iSrc, _iLength );
     }
}
#endif

//Barry 2008-08-18
unsigned long syscall_get_ir( void )
{
	unsigned int value;
	if( exchange_msg( READ_MSG, &value, REMOVE_MSG_AFTER_READ | IR_POOL) == MSG_CMD_OK )
		return (unsigned long) value;
	else
		return 0;
}

void DMA_COPY( unsigned int _iDest, unsigned int _iSrc, unsigned int _iLength ) 
{
//     	if( _iLength == skydma( DMA_CH2, _iDest, _iSrc, _iLength, PRINT_DEBUG_MESSAGE ) ) 
	if( _iLength == skydma( DMA_CH2, _iDest, _iSrc, _iLength, NOT_PRINT_DEBUG_MESSAGE ) ) 
	{
          	// dma copy ok
     	}
     	else 
	{
		printf("DMA_COPY failed = %d\n", _iLength);
          	memcpy( _iDest, _iSrc, _iLength );
     	}
}

unsigned int syscall_get_video_time_onoff( void )
{
	unsigned int value;
	if( exchange_msg( READ_MSG, &value, VIDEOTIME_ONOFF_POOL | NOT_CHANGE_MSG_QUEUE_DATA ) == MSG_CMD_OK )
		return value;
	else
		return 0;
}

void syscall_set_mplayer_duration( unsigned int _iData )
{
	exchange_msg( WRITE_MSG, &_iData, MPLAYER_DURATION_POOL | OVERWRITE_MSG );
}

void syscall_set_mplayer_time( unsigned int _iData )
{
	exchange_msg( WRITE_MSG, &_iData, MPLAYER_TIME_POOL | OVERWRITE_MSG );
}

void syscall_set_mplayer_status( unsigned int _iData )
{
	exchange_msg( WRITE_MSG, &_iData, MPLAYER_STATUS_POOL | OVERWRITE_MSG );
}

void syscall_clear_mplayer_duration( void )
{
	exchange_msg( CLEAR_ALL_MSG, NULL, MPLAYER_DURATION_POOL );
}

void syscall_clear_mplayer_time( void )
{
	exchange_msg( CLEAR_ALL_MSG, NULL, MPLAYER_TIME_POOL);
}
